// Copyright (C) 2006 Pushok Software http://www.pushok.com/soft_svncom.php
//
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
//
// Subversion is Copyrght of(c) 2000-2004 CollabNet.  All rights reserved.
// Full license available here http://subversion.tigris.org/license-1.html.

#pragma once
#include "resource.h"       // main symbols

#include "svn_client.h"
#include "svn_pools.h"

#include "pcom.h"
#include "_ISVNAuthProviderEvents_CP.h"


// CSVNAuthProvider

class ATL_NO_VTABLE CSVNAuthProvider : 
	public CComObjectRootEx<CComMultiThreadModel>,
	public CComCoClass<CSVNAuthProvider, &CLSID_SVNAuthProvider>,
	public IConnectionPointContainerImpl<CSVNAuthProvider>,
	public IDispatchImpl<ISVNAuthProvider, &IID_ISVNAuthProvider, &LIBID_PushOkSvn, /*wMajor =*/ 1, /*wMinor =*/ 0>,
	public CProxy_ISVNAuthProviderEvents<CSVNAuthProvider>
{
public:
	CSVNAuthProvider()
	{
		m_pUnkMarshaler = NULL;
	}

DECLARE_REGISTRY_RESOURCEID(IDR_SVNAUTHPROVIDER)

BEGIN_COM_MAP(CSVNAuthProvider)
	COM_INTERFACE_ENTRY(ISVNAuthProvider)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(IConnectionPointContainer)
	COM_INTERFACE_ENTRY_AGGREGATE(IID_IMarshal, m_pUnkMarshaler.p)
END_COM_MAP()
BEGIN_CONNECTION_POINT_MAP(CSVNAuthProvider)
	CONNECTION_POINT_ENTRY(__uuidof(_ISVNAuthProviderEvents))
END_CONNECTION_POINT_MAP()

	DECLARE_PROTECT_FINAL_CONSTRUCT()
	DECLARE_GET_CONTROLLING_UNKNOWN()

	HRESULT FinalConstruct()
	{
		m_gThis.Attach(this);
		return CoCreateFreeThreadedMarshaler(
			GetControllingUnknown(), &m_pUnkMarshaler.p);
	}

	void FinalRelease()
	{
		m_pUnkMarshaler.Release();
	}

	CComPtr<IUnknown> m_pUnkMarshaler;

private:
	apr_pool_t			*m_pPool;
	svn_auth_baton_t	*m_ab;
	DWORD				m_dwCookie;
	CComBSTR			m_bsDefUserName;
	CComBSTR			m_bsDefPassword;
	CComBSTR			m_bsCertFileName;
	CComBSTR			m_bsRealM;
	VARIANT_BOOL		m_bMaySave;
	LONG				m_lChoice;
	LONG				m_lCookie;
	bool				m_bInterActiv;
	bool				m_bNonInterActiv;
	CComBSTR			m_bsOptConfigDir;
	CComGITPtr<ISVNAuthProvider> m_gThis;
public:
	STDMETHOD(InitEnd)(VARIANT_BOOL bInterActiv, VARIANT_BOOL bNonInterActiv);
	STDMETHOD(get_SvnAuthBaton)(void** pVal);
	STDMETHOD(get_DefUserName)(BSTR* pVal);
	STDMETHOD(put_DefUserName)(BSTR newVal);
	STDMETHOD(get_DefPassword)(BSTR* pVal);
	STDMETHOD(put_DefPassword)(BSTR newVal);
	STDMETHOD(get_CertFileName)(BSTR* pVal);
	STDMETHOD(put_CertFileName)(BSTR newVal);
	STDMETHOD(get_RealM)(BSTR* pVal);
	STDMETHOD(put_RealM)(BSTR newVal);
	STDMETHOD(get_MaySave)(VARIANT_BOOL* pVal);
	STDMETHOD(put_MaySave)(VARIANT_BOOL newVal);
	STDMETHOD(get_Choice)(LONG* pVal);
	STDMETHOD(put_Choice)(LONG newVal);
	STDMETHOD(get_Cookie)(LONG* pVal);
	STDMETHOD(put_Cookie)(LONG newVal);
	STDMETHOD(get_OptConfigDir)(BSTR* pVal);
	STDMETHOD(put_OptConfigDir)(BSTR newVal);
	STDMETHOD(FireAskEvent)(SVNAuthProviderAsk ask, ISVNAuthProvider* pProvider);
	STDMETHOD(Init)(void);
};

OBJECT_ENTRY_AUTO(__uuidof(SVNAuthProvider), CSVNAuthProvider)
