// Copyright (C) 2006 Pushok Software http://www.pushok.com/soft_svncom.php
//
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
//
// Subversion is Copyrght of(c) 2000-2004 CollabNet.  All rights reserved.
// Full license available here http://subversion.tigris.org/license-1.html.

#pragma once
#include "resource.h"       // main symbols

#include "pcom.h"


// CSVNWcLog

class ATL_NO_VTABLE CSVNWcLog : 
	public CComObjectRootEx<CComMultiThreadModel>,
	public CComCoClass<CSVNWcLog, &CLSID_SVNWcLog>,
	public ISupportErrorInfo,
	public IDispatchImpl<ISVNWcLog, &IID_ISVNWcLog, &LIBID_PushOkSvn, /*wMajor =*/ 1, /*wMinor =*/ 0>
{
public:
	CSVNWcLog()
	{
	}

DECLARE_REGISTRY_RESOURCEID(IDR_SVNWCLOG)

BEGIN_COM_MAP(CSVNWcLog)
	COM_INTERFACE_ENTRY(ISVNWcLog)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(ISupportErrorInfo)
	COM_INTERFACE_ENTRY_AGGREGATE(IID_IMarshal, m_pUnkMarshaler.p)
END_COM_MAP()

// ISupportsErrorInfo
	STDMETHOD(InterfaceSupportsErrorInfo)(REFIID riid);

	DECLARE_PROTECT_FINAL_CONSTRUCT()
	DECLARE_GET_CONTROLLING_UNKNOWN()

	HRESULT FinalConstruct()
	{
		return CoCreateFreeThreadedMarshaler(
			GetControllingUnknown(), &m_pUnkMarshaler.p);
	}
	
	void FinalRelease() 
	{
		m_pUnkMarshaler.Release();
	}

	CComPtr<IUnknown> m_pUnkMarshaler;

public:
	STDMETHOD(put_Revision)(LONG newVal) {
		LOCK_THIS_OBJ
		 m_revition = newVal;
		return S_OK;
	}
	STDMETHOD(get_Revision)(LONG* pVal) {
		if (!pVal)
			return E_INVALIDARG;
		LOCK_THIS_OBJ
		*pVal = m_revition;
		return S_OK;
	}

	STDMETHOD(put_Author)(BSTR sVal) {
		LOCK_THIS_OBJ
		m_author = sVal;
		return S_OK;
	}
	STDMETHOD(get_Author)(BSTR* psVal) {
		LOCK_THIS_OBJ
		return m_author.CopyTo(psVal);
	}

	STDMETHOD(put_Date)(BSTR sVal) {
		LOCK_THIS_OBJ
		m_date = sVal;
		return S_OK;
	}
	STDMETHOD(get_Date)(BSTR* psVal) {
		LOCK_THIS_OBJ
		return m_date.CopyTo(psVal);
	}

	STDMETHOD(put_Message)(BSTR sVal) {
		LOCK_THIS_OBJ
		m_message = sVal;
		return S_OK;
	}
	STDMETHOD(get_Message)(BSTR* psVal) {
		LOCK_THIS_OBJ
		return m_message.CopyTo(psVal);
	}

	STDMETHOD(get_CountChangedPaths)(LONG* pVal) {
		if (!pVal)
			return E_INVALIDARG;
		LOCK_THIS_OBJ
		*pVal = (LONG)m_vec_path.size();
		return S_OK;
	}
	STDMETHOD(AddChangedPath)(BSTR sPath, BSTR cAction, BSTR sCopyFrom, LONG nCopyRev) {
		LOCK_THIS_OBJ
		m_vec_path.push_back(sPath);
		m_vec_action.push_back(cAction);
		m_vec_copyfrom.push_back(sCopyFrom);
		m_vec_copyrev.push_back(nCopyRev);
		return S_OK;
	}
	STDMETHOD(GetChangedPath) (LONG iIndex, BSTR* sPath, BSTR* cAction, BSTR* sCopyFrom, LONG *nCopyRev) {
		LOCK_THIS_OBJ
		if (--iIndex>(LONG)m_vec_path.size())
			return E_INVALIDARG;
		if (sPath) (m_vec_path[iIndex]).CopyTo(sPath);
		if (cAction) (m_vec_action[iIndex]).CopyTo(cAction);
		if (sCopyFrom) (m_vec_copyfrom[iIndex]).CopyTo(sCopyFrom);
		if (nCopyRev) *nCopyRev = m_vec_copyrev[iIndex];
		return S_OK;
	}
	STDMETHOD(Clear) (void) {
		LOCK_THIS_OBJ
		m_vec_path.clear();
		m_vec_action.clear();
		m_vec_copyfrom.clear();
		m_vec_copyrev.clear();
		return S_OK;
	}

private:
	LONG m_revition;
	CComBSTR m_author;
	CComBSTR m_date;
	CComBSTR m_message;

	std::vector<CComBSTR> m_vec_path;
	std::vector<CComBSTR> m_vec_action;
	std::vector<CComBSTR> m_vec_copyfrom;
	std::vector<LONG> m_vec_copyrev;
};

OBJECT_ENTRY_AUTO(__uuidof(SVNWcLog), CSVNWcLog)

namespace PushokAtlEx
{
	template <>
	class GenericCopy< VARIANT, ISVNWcLog* >
	{
	public :
		static void init(VARIANT* p)
		{
			GenericCopy<VARIANT>::init(p);
		}
		static void destroy(VARIANT* p)
		{
			GenericCopy<VARIANT>::destroy(p);
		}
		static HRESULT copy( VARIANT *pTo, ISVNWcLog* *pFrom)
		{
			CComVariant vt((IDispatch *)*pFrom);
			return vt.Detach(pTo);
			return S_OK;
		}
	}; // class GenericCopy<VARIANT, ISVNWcNotify* pVal>
}

namespace SVNWcLogVector_
{
	// Store our data in a vector of std::strings
	typedef PushokAtlEx::CComPtrAdapt<ISVNWcLog> ItemType;
	typedef std::vector<ItemType> ContainerType;

	// Now we have all the information we need to fill in the template arguments on the implementation classes
	typedef CComEnumOnSTL< IEnumVARIANT, &__uuidof(IEnumVARIANT), VARIANT,
							PushokAtlEx::GenericCopy< VARIANT, ItemType >, ContainerType > EnumeratorType;

	typedef ICollectionOnSTLImpl< ISVNWcLogVector, ContainerType, ISVNWcLog*,
							PushokAtlEx::GenericCopy<ISVNWcLog*, ItemType>, EnumeratorType > CollectionType;
};

class ATL_NO_VTABLE CSVNWcLogVector : 
	public CComObjectRootEx<CComMultiThreadModel>,
	public CComCoClass<CSVNWcLogVector, &CLSID_SVNWcLogVector>,
	public IDispatchImpl<SVNWcLogVector_::CollectionType,&__uuidof(ISVNWcLogVector)>
{
public:
	CSVNWcLogVector()
	{
	}

DECLARE_REGISTRY_RESOURCEID(IDR_SVNWCLOGVECTOR)

BEGIN_COM_MAP(CSVNWcLogVector)
	COM_INTERFACE_ENTRY(ISVNWcLogVector)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY_AGGREGATE(IID_IMarshal, m_pUnkMarshaler.p)
END_COM_MAP()


	DECLARE_PROTECT_FINAL_CONSTRUCT()
	DECLARE_GET_CONTROLLING_UNKNOWN()

	HRESULT FinalConstruct()
	{
		return CoCreateFreeThreadedMarshaler(
			GetControllingUnknown(), &m_pUnkMarshaler.p);
	}
	
	void FinalRelease() 
	{
		m_pUnkMarshaler.Release();
	}

	CComPtr<IUnknown> m_pUnkMarshaler;

public:
	STDMETHOD(Add)(ISVNWcLog* pVal) {
		LOCK_THIS_OBJ
		m_coll.push_back(pVal);
		return S_OK;
	}
	STDMETHOD(Remove) (long Index) {
		LOCK_THIS_OBJ
		try {
			m_coll.erase(m_coll.begin() + Index);
		} catch(...) {
			return E_FAIL;
		}
		return S_OK;
	}
};

OBJECT_ENTRY_AUTO(__uuidof(SVNWcLogVector), CSVNWcLogVector)